Clazz.declarePackage ("jalview.schemes");
Clazz.load (null, "jalview.schemes.ColourSchemeProperty", ["jalview.schemes.Blosum62ColourScheme", "$.BuriedColourScheme", "$.ClustalxColourScheme", "$.HelixColourScheme", "$.HydrophobicColourScheme", "$.NucleotideColourScheme", "$.PIDColourScheme", "$.PurinePyrimidineColourScheme", "$.RNAHelicesColour", "$.StrandColourScheme", "$.TCoffeeColourScheme", "$.TaylorColourScheme", "$.TurnColourScheme", "$.UserColourScheme", "$.ZappoColourScheme", "jalview.util.ColorUtils", "java.awt.Color"], function () {
c$ = Clazz.declareType (jalview.schemes, "ColourSchemeProperty");
c$.getColourIndexFromName = Clazz.defineMethod (c$, "getColourIndexFromName", 
function (name) {
var ret = -1;
if (name.equalsIgnoreCase ("Clustal")) {
ret = 2;
} else if (name.equalsIgnoreCase ("Blosum62")) {
ret = 3;
} else if (name.equalsIgnoreCase ("% Identity")) {
ret = 4;
} else if (name.equalsIgnoreCase ("Zappo")) {
ret = 5;
} else if (name.equalsIgnoreCase ("Taylor")) {
ret = 6;
} else if (name.equalsIgnoreCase ("Hydrophobic")) {
ret = 7;
} else if (name.equalsIgnoreCase ("Helix Propensity")) {
ret = 8;
} else if (name.equalsIgnoreCase ("Strand Propensity")) {
ret = 9;
} else if (name.equalsIgnoreCase ("Turn Propensity")) {
ret = 10;
} else if (name.equalsIgnoreCase ("Buried Index")) {
ret = 11;
} else if (name.equalsIgnoreCase ("Nucleotide")) {
ret = 12;
} else if (name.equalsIgnoreCase ("T-Coffee Scores")) {
ret = 15;
} else if (name.equalsIgnoreCase ("User Defined")) {
ret = 0;
} else if (name.equalsIgnoreCase ("None")) {
ret = 1;
} else if (name.equalsIgnoreCase ("Purine/Pyrimidine")) {
ret = 13;
} else if (name.equalsIgnoreCase ("RNA Interaction type")) {
ret = 17;
} else if (name.equalsIgnoreCase ("RNA Helices")) {
ret = 16;
}return ret;
}, "~S");
c$.getColourName = Clazz.defineMethod (c$, "getColourName", 
function (cs) {
var index = 1;
if (Clazz.instanceOf (cs, jalview.schemes.ClustalxColourScheme)) {
index = 2;
} else if (Clazz.instanceOf (cs, jalview.schemes.Blosum62ColourScheme)) {
index = 3;
} else if (Clazz.instanceOf (cs, jalview.schemes.PIDColourScheme)) {
index = 4;
} else if (Clazz.instanceOf (cs, jalview.schemes.ZappoColourScheme)) {
index = 5;
} else if (Clazz.instanceOf (cs, jalview.schemes.TaylorColourScheme)) {
index = 6;
} else if (Clazz.instanceOf (cs, jalview.schemes.HydrophobicColourScheme)) {
index = 7;
} else if (Clazz.instanceOf (cs, jalview.schemes.HelixColourScheme)) {
index = 8;
} else if (Clazz.instanceOf (cs, jalview.schemes.StrandColourScheme)) {
index = 9;
} else if (Clazz.instanceOf (cs, jalview.schemes.TurnColourScheme)) {
index = 10;
} else if (Clazz.instanceOf (cs, jalview.schemes.BuriedColourScheme)) {
index = 11;
} else if (Clazz.instanceOf (cs, jalview.schemes.NucleotideColourScheme)) {
index = 12;
} else if (Clazz.instanceOf (cs, jalview.schemes.PurinePyrimidineColourScheme)) {
index = 13;
} else if (Clazz.instanceOf (cs, jalview.schemes.TCoffeeColourScheme)) {
index = 15;
} else if (Clazz.instanceOf (cs, jalview.schemes.RNAHelicesColour)) {
index = 16;
} else if (Clazz.instanceOf (cs, jalview.schemes.UserColourScheme)) {
if (((cs).getName () != null) && ((cs).getName ().length > 0)) {
return (cs).getName ();
}index = 0;
}return jalview.schemes.ColourSchemeProperty.getColourName (index);
}, "jalview.schemes.ColourSchemeI");
c$.getColourName = Clazz.defineMethod (c$, "getColourName", 
function (index) {
var ret = null;
switch (index) {
case 2:
ret = "Clustal";
break;
case 3:
ret = "Blosum62";
break;
case 4:
ret = "% Identity";
break;
case 5:
ret = "Zappo";
break;
case 6:
ret = "Taylor";
break;
case 7:
ret = "Hydrophobic";
break;
case 8:
ret = "Helix Propensity";
break;
case 9:
ret = "Strand Propensity";
break;
case 10:
ret = "Turn Propensity";
break;
case 11:
ret = "Buried Index";
break;
case 12:
ret = "Nucleotide";
break;
case 13:
ret = "Purine/Pyrimidine";
break;
case 15:
ret = "T-Coffee Scores";
break;
case 17:
ret = "RNA Interaction type";
break;
case 16:
ret = "RNA Helices";
break;
case 0:
ret = "User Defined";
break;
default:
ret = "None";
break;
}
return ret;
}, "~N");
c$.getColour = Clazz.defineMethod (c$, "getColour", 
function (alignment, name) {
var colindex = jalview.schemes.ColourSchemeProperty.getColourIndexFromName (name);
if (colindex == -1) {
if (name.indexOf ('=') == -1) {
try {
return  new jalview.schemes.UserColourScheme (name);
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
} else {
throw e;
}
}
} else {
try {
var ucs =  new jalview.schemes.UserColourScheme ("white");
ucs.parseAppletParameter (name);
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
} else {
throw e;
}
}
}}return jalview.schemes.ColourSchemeProperty.getColour (alignment, jalview.schemes.ColourSchemeProperty.getColourIndexFromName (name));
}, "jalview.datamodel.AnnotatedCollectionI,~S");
c$.getColour = Clazz.defineMethod (c$, "getColour", 
function (coll, index) {
var cs = null;
switch (index) {
case 2:
cs =  new jalview.schemes.ClustalxColourScheme (coll, null);
break;
case 3:
cs =  new jalview.schemes.Blosum62ColourScheme ();
break;
case 4:
cs =  new jalview.schemes.PIDColourScheme ();
break;
case 5:
cs =  new jalview.schemes.ZappoColourScheme ();
break;
case 6:
cs =  new jalview.schemes.TaylorColourScheme ();
break;
case 7:
cs =  new jalview.schemes.HydrophobicColourScheme ();
break;
case 8:
cs =  new jalview.schemes.HelixColourScheme ();
break;
case 9:
cs =  new jalview.schemes.StrandColourScheme ();
break;
case 10:
cs =  new jalview.schemes.TurnColourScheme ();
break;
case 11:
cs =  new jalview.schemes.BuriedColourScheme ();
break;
case 12:
cs =  new jalview.schemes.NucleotideColourScheme ();
break;
case 13:
cs =  new jalview.schemes.PurinePyrimidineColourScheme ();
break;
case 15:
cs =  new jalview.schemes.TCoffeeColourScheme (coll);
break;
case 16:
cs =  new jalview.schemes.RNAHelicesColour (coll);
break;
case 0:
var col =  new Array (24);
for (var i = 0; i < 24; i++) {
col[i] = java.awt.Color.white;
}
cs =  new jalview.schemes.UserColourScheme (col);
break;
default:
break;
}
return cs;
}, "jalview.datamodel.AnnotatedCollectionI,~N");
c$.getAWTColorFromName = Clazz.defineMethod (c$, "getAWTColorFromName", 
function (name) {
var col = null;
name = name.toLowerCase ();
if (name.equals ("black")) {
col = java.awt.Color.black;
} else if (name.equals ("blue")) {
col = java.awt.Color.blue;
} else if (name.equals ("cyan")) {
col = java.awt.Color.cyan;
} else if (name.equals ("darkGray")) {
col = java.awt.Color.darkGray;
} else if (name.equals ("gray")) {
col = java.awt.Color.gray;
} else if (name.equals ("green")) {
col = java.awt.Color.green;
} else if (name.equals ("lightGray")) {
col = java.awt.Color.lightGray;
} else if (name.equals ("magenta")) {
col = java.awt.Color.magenta;
} else if (name.equals ("orange")) {
col = java.awt.Color.orange;
} else if (name.equals ("pink")) {
col = java.awt.Color.pink;
} else if (name.equals ("red")) {
col = java.awt.Color.red;
} else if (name.equals ("white")) {
col = java.awt.Color.white;
} else if (name.equals ("yellow")) {
col = java.awt.Color.yellow;
}return col;
}, "~S");
c$.initRnaHelicesShading = Clazz.defineMethod (c$, "initRnaHelicesShading", 
function (n) {
var j = 0;
if (jalview.schemes.ColourSchemeProperty.rnaHelices == null) {
jalview.schemes.ColourSchemeProperty.rnaHelices =  new Array (n + 1);
} else if (jalview.schemes.ColourSchemeProperty.rnaHelices != null && jalview.schemes.ColourSchemeProperty.rnaHelices.length <= n) {
var t =  new Array (n + 1);
System.arraycopy (jalview.schemes.ColourSchemeProperty.rnaHelices, 0, t, 0, jalview.schemes.ColourSchemeProperty.rnaHelices.length);
j = jalview.schemes.ColourSchemeProperty.rnaHelices.length;
jalview.schemes.ColourSchemeProperty.rnaHelices = t;
} else {
return;
}for (; j <= n; j++) {
jalview.schemes.ColourSchemeProperty.rnaHelices[j] = jalview.util.ColorUtils.generateRandomColor (java.awt.Color.white);
}
}, "~N");
Clazz.defineStatics (c$,
"UNDEFINED", -1,
"USER_DEFINED", 0,
"NONE", 1,
"CLUSTAL", 2,
"BLOSUM", 3,
"PID", 4,
"ZAPPO", 5,
"TAYLOR", 6,
"HYDROPHOBIC", 7,
"HELIX", 8,
"STRAND", 9,
"TURN", 10,
"BURIED", 11,
"NUCLEOTIDE", 12,
"PURINEPYRIMIDINE", 13,
"COVARIATION", 14,
"TCOFFEE", 15,
"RNAHELIX", 16,
"RNAINTERACTION", 17,
"FIRST_COLOUR", 1,
"LAST_COLOUR", 17,
"rnaHelices", null);
});
