Clazz.declarePackage ("jalview.util");
Clazz.load (["java.util.HashMap"], "jalview.util.DBRefUtils", ["jalview.datamodel.DBRefEntry", "$.DBRefSource", "$.PDBEntry", "jalview.jsdev.RegExp", "java.util.ArrayList", "$.Hashtable"], function () {
c$ = Clazz.declareType (jalview.util, "DBRefUtils");
c$.selectRefs = Clazz.defineMethod (c$, "selectRefs", 
function (dbrefs, sources) {
if (dbrefs == null) {
return null;
}if (sources == null) {
return dbrefs;
}var srcs =  new java.util.HashMap ();
var res =  new java.util.ArrayList ();
for (var i = 0; i < sources.length; i++) {
srcs.put ( String.instantialize (sources[i]),  new Integer (i));
}
for (var i = 0, j = dbrefs.length; i < j; i++) {
if (srcs.containsKey (dbrefs[i].getSource ())) {
res.add (dbrefs[i]);
}}
if (res.size () > 0) {
var reply =  new Array (res.size ());
return res.toArray (reply);
}res = null;
return null;
}, "~A,~A");
c$.isDasCoordinateSystem = Clazz.defineMethod (c$, "isDasCoordinateSystem", 
function (string, dBRefEntry) {
if (string == null || dBRefEntry == null) {
return false;
}var coordsys = jalview.util.DBRefUtils.dasCoordinateSystemsLookup.get (string.toLowerCase ());
return coordsys == null ? false : coordsys.equals (dBRefEntry.getSource ());
}, "~S,jalview.datamodel.DBRefEntry");
c$.getCanonicalName = Clazz.defineMethod (c$, "getCanonicalName", 
function (source) {
if (source == null) {
return null;
}var canonical = jalview.util.DBRefUtils.canonicalSourceNameLookup.get (source.toLowerCase ());
return canonical == null ? source : canonical;
}, "~S");
c$.searchRefs = Clazz.defineMethod (c$, "searchRefs", 
function (ref, entry) {
return jalview.util.DBRefUtils.searchRefs (ref, entry, jalview.util.DBRefUtils.matchDbAndIdAndEitherMapOrEquivalentMapList);
}, "~A,jalview.datamodel.DBRefEntry");
c$.searchRefs = Clazz.defineMethod (c$, "searchRefs", 
function (refs, entry, comparator) {
if (refs == null || entry == null) {
return null;
}var rfs =  new java.util.ArrayList ();
for (var i = 0; i < refs.length; i++) {
if (comparator.matches (entry, refs[i])) {
rfs.add (refs[i]);
}}
return rfs.size () == 0 ? null : rfs.toArray ( new Array (rfs.size ()));
}, "~A,jalview.datamodel.DBRefEntry,jalview.util.DBRefUtils.DbRefComp");
c$.parseToDbRef = Clazz.defineMethod (c$, "parseToDbRef", 
function (seq, dbname, version, acn) {
var ref = null;
if (dbname != null) {
var locsrc = jalview.util.DBRefUtils.getCanonicalName (dbname);
if (locsrc.equals (jalview.datamodel.DBRefSource.PDB)) {
var r = jalview.jsdev.RegExp.newRegex (["([0-9][0-9A-Za-z]{3})\\s*(.?)\\s*;\\s*([0-9]+)-([0-9]+)"]);
if (r.search (acn.trim ())) {
var pdbid = r.stringMatchedI (1);
var chaincode = r.stringMatchedI (2);
if (chaincode == null) {
chaincode = " ";
}if (chaincode.equals (" ")) {
chaincode = "_";
}ref =  new jalview.datamodel.DBRefEntry (locsrc, version, pdbid + chaincode);
var pdbr =  new jalview.datamodel.PDBEntry ();
pdbr.setId (pdbid);
pdbr.setType (jalview.datamodel.PDBEntry.Type.PDB);
pdbr.setProperty ( new java.util.Hashtable ());
pdbr.setChainCode (chaincode);
seq.addPDBId (pdbr);
} else {
System.err.println ("Malformed PDB DR line:" + acn);
}} else {
ref =  new jalview.datamodel.DBRefEntry (locsrc, version, acn);
}}if (ref != null) {
seq.addDBRef (ref);
}return ref;
}, "jalview.datamodel.SequenceI,~S,~S,~S");
c$.$DBRefUtils$1$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$1", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if (refa.getSource () == null || refb.getSource ().equals (refa.getSource ())) {
if (refa.getVersion () == null || refb.getVersion ().equals (refa.getVersion ())) {
if (refa.getAccessionId () == null || refb.getAccessionId ().equals (refa.getAccessionId ())) {
if (refa.getMap () == null || (refb.getMap () != null && refb.getMap ().equals (refa.getMap ()))) {
return true;
}}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
c$.$DBRefUtils$2$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$2", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if ((refa.getSource () == null || refb.getSource () == null) || refb.getSource ().equals (refa.getSource ())) {
if ((refa.getVersion () == null || refb.getVersion () == null) || refb.getVersion ().equals (refa.getVersion ())) {
if ((refa.getAccessionId () == null || refb.getAccessionId () == null) || refb.getAccessionId ().equals (refa.getAccessionId ())) {
if ((refa.getMap () == null || refb.getMap () == null) || (refb.getMap () != null && refb.getMap ().equals (refa.getMap ()))) {
return true;
}}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
c$.$DBRefUtils$3$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$3", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if (refa.getSource () != null && refb.getSource () != null && refb.getSource ().equals (refa.getSource ())) {
if (refa.getAccessionId () != null && refb.getAccessionId () != null || refb.getAccessionId ().equals (refa.getAccessionId ())) {
if ((refa.getMap () == null || refb.getMap () == null) || (refa.getMap () != null && refb.getMap () != null && refb.getMap ().equals (refa.getMap ()))) {
return true;
}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
c$.$DBRefUtils$4$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$4", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if (refa.getSource () != null && refb.getSource () != null && refb.getSource ().equals (refa.getSource ())) {
if (refa.getAccessionId () != null && refb.getAccessionId () != null || refb.getAccessionId ().equals (refa.getAccessionId ())) {
if ((refa.getMap () == null && refb.getMap () == null) || (refa.getMap () != null && refb.getMap () != null)) {
if ((refb.getMap ().getMap () == null && refa.getMap ().getMap () == null) || (refb.getMap ().getMap () != null && refa.getMap ().getMap () != null && refb.getMap ().getMap ().getInverse ().equals (refa.getMap ().getMap ()))) {
return true;
}}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
c$.$DBRefUtils$5$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$5", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if (refa.getSource () != null && refb.getSource () != null && refb.getSource ().equals (refa.getSource ())) {
if (refa.getAccessionId () != null && refb.getAccessionId () != null || refb.getAccessionId ().equals (refa.getAccessionId ())) {
if (refa.getMap () == null && refb.getMap () == null) {
return true;
}if (refa.getMap () != null && refb.getMap () != null && ((refb.getMap ().getMap () == null && refa.getMap ().getMap () == null) || (refb.getMap ().getMap () != null && refa.getMap ().getMap () != null && refb.getMap ().getMap ().equals (refa.getMap ().getMap ())))) {
return true;
}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
c$.$DBRefUtils$6$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.declareAnonymous (jalview.util, "DBRefUtils$6", null, jalview.util.DBRefUtils.DbRefComp);
Clazz.defineMethod (c$, "matches", 
function (refa, refb) {
if (refa.getSource () != null && refb.getSource () != null && refb.getSource ().equals (refa.getSource ())) {
if (refa.getAccessionId () != null && refb.getAccessionId () != null && refb.getAccessionId ().equals (refa.getAccessionId ())) {
if (refa.getMap () == null || refb.getMap () == null) {
return true;
}if ((refa.getMap () != null && refb.getMap () != null) && (refb.getMap ().getMap () == null && refa.getMap ().getMap () == null) || (refb.getMap ().getMap () != null && refa.getMap ().getMap () != null && (refb.getMap ().getMap ().equals (refa.getMap ().getMap ())))) {
return true;
}}}return false;
}, "jalview.datamodel.DBRefEntry,jalview.datamodel.DBRefEntry");
c$ = Clazz.p0p ();
};
Clazz.declareInterface (jalview.util.DBRefUtils, "DbRefComp");
c$.canonicalSourceNameLookup = c$.prototype.canonicalSourceNameLookup =  new java.util.HashMap ();
c$.dasCoordinateSystemsLookup = c$.prototype.dasCoordinateSystemsLookup =  new java.util.HashMap ();
{
jalview.util.DBRefUtils.canonicalSourceNameLookup.put ("uniprotkb/swiss-prot", jalview.datamodel.DBRefSource.UNIPROT);
jalview.util.DBRefUtils.canonicalSourceNameLookup.put ("uniprotkb/trembl", jalview.datamodel.DBRefSource.UNIPROT);
jalview.util.DBRefUtils.canonicalSourceNameLookup.put ("pdb", jalview.datamodel.DBRefSource.PDB);
jalview.util.DBRefUtils.dasCoordinateSystemsLookup.put ("pdbresnum", jalview.datamodel.DBRefSource.PDB);
jalview.util.DBRefUtils.dasCoordinateSystemsLookup.put ("uniprot", jalview.datamodel.DBRefSource.UNIPROT);
jalview.util.DBRefUtils.dasCoordinateSystemsLookup.put ("embl", jalview.datamodel.DBRefSource.EMBL);
}c$.matchNonNullonA = c$.prototype.matchNonNullonA = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$1") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$1$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$1, this, null));
c$.matchEitherNonNull = c$.prototype.matchEitherNonNull = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$2") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$2$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$2, this, null));
c$.matchDbAndIdAndEitherMap = c$.prototype.matchDbAndIdAndEitherMap = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$3") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$3$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$3, this, null));
c$.matchDbAndIdAndComplementaryMapList = c$.prototype.matchDbAndIdAndComplementaryMapList = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$4") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$4$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$4, this, null));
c$.matchDbAndIdAndEquivalentMapList = c$.prototype.matchDbAndIdAndEquivalentMapList = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$5") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$5$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$5, this, null));
c$.matchDbAndIdAndEitherMapOrEquivalentMapList = c$.prototype.matchDbAndIdAndEitherMapOrEquivalentMapList = ((Clazz.isClassDefined ("jalview.util.DBRefUtils$6") ? 0 : jalview.util.DBRefUtils.$DBRefUtils$6$ ()), Clazz.innerTypeInstance (jalview.util.DBRefUtils$6, this, null));
});
